#autor: Antonn Neumann
#osobn slo: A11B0439P
#program: Klouzav prmr
#zkratky:
# DB - Delay Branches

	.data

	vstup:			.asciiz "Vloz cislo: "
	mimotxt:		.asciiz "Zadan slo musi byt int16\n"
	prumertxt:	.asciiz "Prumer "
	radek:      .asciiz "\n"
	values:			.asciiz "Hodnoty "
	carka:      .asciiz ", "

	.text
	.globl	main
main:	#start
		move $t0, $zero
		move $t1, $zero
		move $t2, $zero
		move $t3, $zero
		move $t4, $zero
    move $t5, $zero
    move $t6, $zero
    move $t7, $zero
		move $s0, $ra     #uloen nvratov hodnoty do OS
		move $s1, $zero		#aktuln prmr
		li $s2, 8     		#poet sel
		li $s3, 33000			#ukonujc slo

#naten 1. sla
prvni:
		jal nacti       #nate slo
		nop
    
    jal prumer      #vypote prmr
		move $t0, $v0   #ulo slo #kvli zpodnmu skoku uvedeno a za "jal prumer"
		
    jal tisk        #vytiskne hodnoty a jejich prmr
		move $s1, $v0   #ulo prmer #kvli zpodnmu skoku uvedeno a za "jal tisk"

#naten 2. sla
druhe:
		jal nacti
		nop

    jal prumer
    move $t1, $v0
    
		jal tisk
    move $s1, $v0   #ulo prmer

#naten 3. sla
treti:
		jal nacti
		nop

		jal prumer
    move $t2, $v0
    
		jal tisk
    move $s1, $v0   #ulo prmer

#naten 4. sla
ctvrte:
		jal nacti
		nop

    jal prumer
    move $t3, $v0

		jal tisk
    move $s1, $v0   #ulo prmer

#naten 5. sla
pate:
		jal nacti
		nop

		jal prumer
    move $t4, $v0
    
    jal tisk
    move $s1, $v0   #ulo prmer

#naten 6. sla
seste:
		jal nacti
		nop

    jal prumer
    move $t5, $v0
		
    jal tisk
    move $s1, $v0   #ulo prmer

#naten 7. sla
sedme:
		jal nacti
		nop

    jal prumer
    move $t6, $v0
    
		jal tisk
    move $s1, $v0   #ulo prmer

#naten 8. sla
osme:
		jal nacti       #nate slo
		nop

		jal prumer      #vypote prmr
    move $t7, $v0   #ulo naten slo
		
		jal tisk        #tisk
    move $s1, $v0   #ulo prmer
 
		jal prvni       #znovu zanu natat sla od prvnho
		nop


prumer:
		add $v0, $t0, $t1 #$v0 <- $t0 + $t1
		add $v0, $v0, $t2 #$v0 <- $v0 + $t2
    add $v0, $v0, $t3 #$v0 <- $v0 + $t3
    add $v0, $v0, $t4 #$v0 <- $v0 + $t4
    add $v0, $v0, $t5 #$v0 <- $v0 + $t5
    add $v0, $v0, $t6 #$v0 <- $v0 + $t6
    add $v0, $v0, $t7 #$v0 <- $v0 + $t7
		div $v0, $s2		 	#$v0 <- $v0 / 8, vsledek je v registru $LO
		j $ra             #nvrat na msto odkud byt podprogram zavoln
    #DELAY BRANCHES
		mflo $v0          #pesun vsledku z $LO do $v0 
		#nop

nacti:
		#vytistne etzec
		li	$v0,4
		la	$a0,vstup
		syscall

		#nate slo
		li	$v0,5
		syscall
    nop #DB
		beq $v0, $s3, exit
		nop #DB
		bge $v0, 32767, mimo
		nop #DB
		ble $v0, -32768, mimo
		nop #DB
		j $ra
		nop #DB

mimo:
		#vytiskne etzec (nen int16)
    li	$v0, 4
		la	$a0, mimotxt
		syscall
		j nacti
		nop


tisk:
#tisk hodnot
		li	$v0, 4
		la	$a0, values
		syscall

    li $v0, 1
		move $a0, $t0
		syscall
    li	$v0, 4
		la	$a0, carka
		syscall

    li $v0, 1
		move $a0, $t1
		syscall
    li	$v0, 4
		la	$a0, carka
		syscall

    li $v0, 1
		move $a0, $t2
		syscall
    li	$v0, 4
		la	$a0, carka
		syscall

    li $v0, 1
		move $a0, $t3
		syscall
    li	$v0, 4
		la	$a0, carka
		syscall

    li $v0, 1
		move $a0, $t4
		syscall
    li	$v0, 4
		la	$a0, carka
		syscall

    li $v0, 1
		move $a0, $t5
		syscall
    li	$v0, 4
		la	$a0, carka
		syscall

    li $v0, 1
		move $a0, $t6
		syscall
    li	$v0, 4
		la	$a0, carka
		syscall

    li $v0, 1
		move $a0, $t7
		syscall
    li	$v0, 4
		la	$a0, radek
		syscall

#tisk prumeru
		li	$v0, 4
		la	$a0, prumertxt
		syscall

    li $v0, 1
		move $a0, $s1
		syscall

    li	$v0, 4
		la	$a0, radek
		syscall

		j $ra
		nop

exit:
	move $ra, $s0
	jr $ra
	nop